=== debian/changelog ===
ufc (2.3.0-1) unstable; urgency=low

  * New upstream release.
  * debian/watch: Update URL for move to Bitbucket.
  * debian/docs: README -> README.rst
  * Remove debian/ufc-doc.docs and ufc-doc.doc-base.
  * debian/control: Remove binary package ufc-doc.

 -- Johannes Ring <johannr@simula.no>  Wed, 26 Jun 2013 12:01:15 +0200
