=== debian/control ===
Source: ufc
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: debhelper (>= 9),
 python-dev (>= 2.6.6-3~),
 cmake (>= 2.8.0),
 swig2.0,
 libboost-dev
Standards-Version: 3.9.4
X-Python-Version: >= 2.5
Homepage: http://fenicsproject.org
Vcs-Svn: svn://anonscm.debian.org/debian-science/packages/fenics/ufc/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/fenics/ufc/trunk/

Package: ufc
Section: devel
Architecture: any
Depends: ${misc:Depends}
Suggests: ufc-doc
Description: unified code generation interface for form-compilers
 UFC (Unified Form-assembly Code) is a unified framework for finite element
 assembly. More precisely, it defines a fixed interface for communicating low
 level routines (functions) for evaluating and assembling finite element
 variational forms. The UFC interface consists of a single header file ufc.h
 that specifies a C++ interface that must be implemented by code that complies
 with the UFC specification. Examples of form compilers that support the UFC
 interface are FFC and SyFi.

Package: python-ufc
Section: python
Architecture: any
Depends: ufc (= ${binary:Version}),
 ${python:Depends},
 ${shlibs:Depends}, 
 ${misc:Depends}
Description: Python utilities (templates) for generating UFC code
 UFC (Unified Form-assembly Code) is a unified framework for finite element
 assembly. More precisely, it defines a fixed interface for communicating low
 level routines (functions) for evaluating and assembling finite element
 variational forms. The UFC interface consists of a single header file ufc.h
 that specifies a C++ interface that must be implemented by code that complies
 with the UFC specification. Examples of form compilers that support the UFC
 interface are FFC and SyFi.
 .
 This package contains Python utilities for generating UFC code.
