=== debian/watch ===
version=3
https://bitbucket.org/fenics-project/ufc/downloads/ufc-(.*)\.tar\.gz
